// GQD Version 1.3 modified by T.Kouya
// from Version 1.2 at https://code.google.com/p/gpuprec/

#ifndef _CUDA_HEADER_CU_
#define _CUDA_HEADER_CU_

#include <stdio.h>
#include <stdlib.h>



// cutilCheckMsg
//#include "helper_cuda.h"
#define cutilCheckMsg getLastCudaError
#define CUT_SAFE_CALL(function) function
#define CUDA_SAFE_CALL(function) function
#define cutilSafeCall(function) function

// cuCreateTimer
//#include "helper_timer.h"

/* kernel macros */
#define NUM_TOTAL_THREAD (gridDim.x * blockDim.x)
#define GLOBAL_THREAD_OFFSET (blockDim.x * blockIdx.x + threadIdx.x)

/** macro utility */
#define GPUMALLOC(D_DATA, MEM_SIZE) cutilSafeCall(cudaMalloc(D_DATA, MEM_SIZE))
#define TOGPU(D_DATA, H_DATA, MEM_SIZE) cutilSafeCall(cudaMemcpy(D_DATA, H_DATA, MEM_SIZE, cudaMemcpyHostToDevice))
#define FROMGPU( H_DATA, D_DATA, MEM_SIZE ) cutilSafeCall(cudaMemcpy( H_DATA, D_DATA, MEM_SIZE, cudaMemcpyDeviceToHost))
#define GPUTOGPU( DEST, SRC, MEM_SIZE ) cutilSafeCall(cudaMemcpy( DEST, SRC, MEM_SIZE, cudaMemcpyDeviceToDevice ))
#define GPUFREE( MEM ) cutilSafeCall(cudaFree(MEM));

#if 0
/** timer utility */
void startTimer(StopWatchInterface **timer)
{
	sdkCreateTimer(timer);
	sdkStartTimer(timer);
}

float endTimer(StopWatchInterface **timer, char* title )
{
	sdkStopTimer(timer);
	float ms = sdkGetTimerValue(timer);	
	printf( "*** %s processing time: %.3f sec ***\n", title, ms/1000.0);
	sdkDeleteTimer(timer);

	return ms;
}

#endif // 0

#endif // _CUDA_HEADER_CU_

